#ifndef List_h              //Prog8.4

#define List_h 1

#include <string.h>

#include <iostream.h>

template <class ElementType>

class List 

{

  public:

    
      //	This constructor allocates the memory required for the
      //	list and initializes the attributes.

      List (int size_of_list);

      
      //	This constructor initializes the attributes.  Note that
      //	the memory is allocated externally.

      List (int size_of_list, ElementType* array_ptr);


     
      //	This constructor is the default constructor

      List ();


      ~List();

    
      //	This operation gets the element associated with the
      //	specified index.

      ElementType* get_element (int index) const;


      
      //	This operation puts the given element at the specified
      //	index.

      void put_element (int index, ElementType& element);

      
      //	This operation returns the size of the list (size).
      int get_size () const;


    
  private:

    // Data Members for Class Attributes

      
      //	This attribute is the maximum number of items that the
      //	list can contain.

      
      int size;
      
  
      //	This attribute is the array of elements.
      
      ElementType* element_type_array;
	 
      
};


template <class ElementType>

inline ElementType * List<ElementType>::get_element (int index) const

{

   //ElementType *elt;
   //elt=&element_type_array[index];

   return &element_type_array[index];

}

template <class ElementType>

inline void List<ElementType>::put_element (int index, ElementType& element)

{ 
   element_type_array[index]=element; 
   
}


template <class ElementType>

inline int List<ElementType>::get_size () const

{

    return size;

}




#endif
