#include "LinkedList.h"      //Prog8.6
                             //LinkedList.cpp
 
template <class Type> 

LinkedList<Type>::LinkedList ()

  
{

     the_head = NULL;

     the_tail = NULL;
	 
}



template <class Type>

void LinkedList<Type>::prepend (Link<Type> * const element)

{

   element->set_previous(NULL);

   element->set_next(the_head);


   if (the_head == NULL)

   {

      the_tail = (Link<Type>*) element;

   }

   else

   {

      the_head->set_previous (element);

   }


   the_head = (Link<Type>*)element;

}
        
  

template <class Type>

void LinkedList<Type>::append (Link<Type>* const element)

{

  
   element->set_previous(the_tail);


   if (the_tail == NULL)

   {

      the_head = (Link<Type>*)element;

   }

   else

   {

      the_tail->set_next (element);

   }


   the_tail = (Link<Type>*)element;

}


template <class Type>

void LinkedList<Type>::extract (Link <Type>* const element)

{

   Link<Type> * temp;

        
   if ((temp = (Link<Type> *)element->get_previous()) == NULL)

   {

      the_head = (Link<Type> *)element->get_next();

   }

   else

   {

      temp->set_next ((Link<Type> *const)element->get_next());

   }


   if ((temp = (Link<Type> *)element->get_next()) == NULL)

   {

      the_tail = (Link<Type> *)element->get_previous();

   }

   else

   {

      temp->set_previous ((Link<Type> *const)element->get_previous());

   }

}


template <class Type>

void LinkedList<Type>::insert_after (Link <Type>* const link, Link <Type>* const after_link)

{

   Link<Type> *temp;


   link->set_previous(after_link);

   link->set_next ((Link<Type> *)after_link->get_next());


   after_link->set_next (link);


   if ((temp = (Link<Type> *)link->get_next()) == NULL)

   {

      the_tail = (Link<Type>*)link;

   }

   else

   {

      temp->set_previous(link);

   }

}


template <class Type>

void LinkedList<Type>::insert_before (Link <Type>* const link, Link<Type> * const before_link)

{

   Link<Type> *temp;


   link->set_next(before_link);

   link->set_previous((Link<Type> *)before_link->get_previous());


   before_link->set_previous(link);
   

   if ((temp = (Link<Type> *)link->get_previous()) == NULL)

   {

      the_head = (Link<Type>*)link;

   }

   else

   {

      temp->set_next(link); 

   }

}


template <class Type>

Bool LinkedList<Type>::is_empty ()

{

   return (the_head == NULL);

}


