#ifndef LinkedList_h         //Prog8.6   LinkedList.h

#define LinkedList_h 1



//#include "types.h"


#include "Link.h"


typedef int Uinit16;

typedef bool Bool;


template <class Type>

class LinkedList 

{

  public:

   
      //	This constructor is intended to create an empty linked
      //	list.  This constructor shall set the_head and the_tail
      //	to NULL.

      LinkedList ();


      //	This operation shall place the given link at the
      //	begining of the linked list.

      void prepend (Link<Type> * const element);


      //	This operation shall place the given element at the end
      //	of the linked list

      void append (Link<Type>* const element);


      //	This operation shall remove the indicated link from the
      //	linked list.

      void extract (Link <Type>* const element);


      //	This operation shall insert the given link after the
      //	link specified by after_link.

      void insert_after (Link <Type>* const link, Link <Type>* const after_link);


      //	This operation shall insert the given link before the
      //	link specified by before_link.

      void insert_before (Link <Type>* const link, Link<Type> * const before_link);


      //	This operation shall return a pointer to the first link
      //	in the list.

      Link<Type>* first ();


      //	This operation shall return a pointer to the last link
      //	in the list.

      Link <Type>* last ();


      //	This operation shall return true if the list is empty.

      Bool is_empty ();


    
  private:

   
      Link <Type> *the_head;

      Link <Type> *the_tail;

};



template <class Type>

inline Link<Type>* LinkedList<Type>::first ()

{ 
	
   return the_head;

}


template <class Type>

inline Link <Type>* LinkedList<Type>::last ()

{

   return the_tail;

}


#endif
