#ifndef LinkedListIterator_h         //Prog8.6

#define LinkedListIterator_h 1       //LinkedIterator.h

//#include "types.h"

#include "LinkedList.h"

// Link

#include "Link.h"


//	This class provides methods to traverse through a linked
//	list


template <class Type>

class LinkedListIterator 

{

  public:

    
      //	This constructor shall  initialize the_linked_list and
      //	then set current to the first element of the provided
      //	list.

      LinkedListIterator (const LinkedList<Type> *list);



   
      //	This operation shall provide the next element in the
      //	linked list from the current element.  NULL shall be
      //	returned if the current element is the last element.

      Link<Type> * next ();


  
      //	This operation shall provide the previous element in the
      //	linked list from the current element.  NULL shall be
      //	returned if the current element is the first element.

      Link <Type>* previous ();


     
      //	This operation shall set the current element to the
      //	first element in the linked list and return the pointer
      //	to the first element.

      Link <Type>* to_first ();


      
      //	This operation shall set the current element of the
      //	linked list to the last element of the list and return a
      //	pointer to the last element in the linked list.

      Link<Type> * to_last ();


      
      //	This operation shall return current.

      Link <Type>* get_current ();


    


  private:

    
      LinkedList <Type> *the_linked_list;

      Link <Type>       *current;

  
};  // Parameterized Class LinkedListIterator 


#endif
