#include <iostream.h>           //Prog4.12

#include <string.h>

enum { OPEN, CLOSED };

class Operator;

class Valve {

private:

    char name[30];

    bool valve_status;

    static Operator *theOperator;

public:

	void set_name(const char* string) {

		strcpy(name, string);

	}

	const char* get_name() const { return name; }

	void set_valve_status(bool status) { valve_status = status; }

	const bool get_valve_status() const { return valve_status; }

	void set_theOperator(Operator* ptr) { theOperator = ptr; }

    const Operator* get_theOperator() const { return theOperator; }

	const char* get_operator_name(int i) const; //Unable to define in-line because
	
	                           //class Operator has not yet been declared

};

//

class Operator {

private:

    char name[30];

	static Valve *theValve;

public:	
	
    void set_theValve(Valve* ptr) { theValve = ptr; }

    const Valve* get_theValve() const { return theValve; }

	void set_name(const char* string) {

		strcpy(name, string);

	}

	const char* get_name() const { return name; }

	void close_valve(int i) { theValve[i].set_valve_status(CLOSED); }

	const char* get_valve_name(int i) const { return theValve[i].get_name(); }

	const bool get_valve_status(int i) const { return theValve[i].get_valve_status(); }

};

//class Operator has been declared, so the following operation can now be defined

const char* Valve::get_operator_name(int i) const { return theOperator[i].get_name(); }

Operator* Valve::theOperator = 0;

Valve* Operator::theValve = 0;

//
void main() {

   int i;

   Operator *optr = new Operator[4];

   Valve *valve = new Valve[4];

   optr -> set_theValve( valve );

   valve -> set_theOperator( optr );

   optr[0].set_name("Brian Jones");

   optr[1].set_name("Bob Calvert");

   optr[2].set_name("Jimmy Logan");

   optr[3].set_name("Bal Khrishnan");
   
   valve[0].set_name("Valve_1");

   valve[1].set_name("Valve_2");

   valve[2].set_name("Valve_3");

   valve[3].set_name("Valve_4");

   for( i = 0; i<4; ++i ) valve[i].set_valve_status(OPEN);

   //Valve object valve[i] is asked to get name from Operator object theOperator[i].

   //Operator object optr[i] is asked to get name from Valve object theValve[i].

   //Operator object optr[i] is asked to get valve_status from Valve object theValve[i].

   //This illustrates inter-object communication via class association.

   //What a funny way to do things !!!!!!!!

   for ( i = 0; i < 4; ++i ) {  
	   
       cout << valve[i].get_operator_name(i) << "     "

            << optr[i].get_valve_name(i) << "     " 

	        << "valve_status = " <<  optr[i].get_valve_status(i) << endl;
  }

   cout << "Initialization Complete" << endl << endl <<endl;


   //Directly asking operator object for its name, valve object 

   //for its name and valve_status.

   cout << optr[0].get_name() << "     " << valve[0].get_name()

        << "     " << valve[0].get_valve_status() << endl;

   optr[3].close_valve(2);

   //Asking object valve to get          theOperator -> name, 

   //and object optr to get              theValve -> status.

   //This illustrates inter-object communication via class association.

   cout << valve[1].get_operator_name(3) << "     " 

        << optr[2].get_valve_name(2) << "     " 

        << optr[3].get_valve_status(2) << endl;

  //Explicitly delete 4 + 4 objects created in the heap by operator new to

  //avoid memory leak.

   delete [4] optr;

   delete [4] valve;

}